import { Sdk, InputMaybe, BackendErrorObjectInput } from './graph/generated/operations';
import { NodeOptions } from './types';
import { ErrorContext } from './errorContext';
export interface StackFrameWithSource extends Pick<StackFrame, 'args' | 'evalOrigin' | 'isConstructor' | 'isEval' | 'isNative' | 'isToplevel' | 'columnNumber' | 'lineNumber' | 'fileName' | 'functionName' | 'source'> {
    lineContent?: string;
    linesBefore?: string;
    linesAfter?: string;
}
export declare class Highlight {
    readonly FLUSH_TIMEOUT = 10;
    _graphqlSdk: Sdk;
    _backendUrl: string;
    _intervalFunction: ReturnType<typeof setInterval>;
    errors: Array<InputMaybe<BackendErrorObjectInput>>;
    _errorContext: ErrorContext | undefined;
    constructor(options: NodeOptions);
    consumeCustomError(error: Error, secureSessionId: string, requestId: string): void;
    flush(): void;
}
